"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegEnum = void 0;
/**
 * 正则的枚举
 */
class RegEnum {
    static get TEL() {
        return this._TEL;
    }
    static set TEL(value) {
        this._TEL = value;
    }
    static get PHONE() {
        return this._PHONE;
    }
    static set PHONE(value) {
        this._PHONE = value;
    }
    static get IDCARD15() {
        return this._IDCARD15;
    }
    static set IDCARD15(value) {
        this._IDCARD15 = value;
    }
    static get IDCARD18() {
        return this._IDCARD18;
    }
    static set IDCARD18(value) {
        this._IDCARD18 = value;
    }
    static get EMAIL() {
        return this._EMAIL;
    }
    static set EMAIL(value) {
        this._EMAIL = value;
    }
    static get INTEGER() {
        return this._INTEGER;
    }
    static set INTEGER(value) {
        this._INTEGER = value;
    }
    static get NUMBER() {
        return this._NUMBER;
    }
    static set NUMBER(value) {
        this._NUMBER = value;
    }
    static get ENCHAR() {
        return this._ENCHAR;
    }
    static set ENCHAR(value) {
        this._ENCHAR = value;
    }
    static get ENCHARD() {
        return this._ENCHARD;
    }
    static set ENCHARD(value) {
        this._ENCHARD = value;
    }
    static get ENCHARX() {
        return this._ENCHARX;
    }
    static set ENCHARX(value) {
        this._ENCHARX = value;
    }
    static get ENCHARXN() {
        return this._ENCHARXN;
    }
    static set ENCHARXN(value) {
        this._ENCHARXN = value;
    }
    static get ENCHAR_N() {
        return this._ENCHAR_N;
    }
    static set ENCHAR_N(value) {
        this._ENCHAR_N = value;
    }
    static get CN() {
        return this._CN;
    }
    static set CN(value) {
        this._CN = value;
    }
    static get URL() {
        return this._URL;
    }
    static set URL(value) {
        this._URL = value;
    }
}
exports.RegEnum = RegEnum;
/**
 * 手机号码
 */
RegEnum._PHONE = /^1(3|4|5|6|7|8|9)\d{9}$/;
/**
 * 身份号码15位
 */
RegEnum._IDCARD15 = /^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$/;
/**
 * 身份证号码18位
 */
RegEnum._IDCARD18 = /^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{4}$/;
/**
 * 邮箱
 */
RegEnum._EMAIL = /^\w+@[a-z0-9]+\.[a-z]+$/i;
/**
 * 整数
 */
RegEnum._INTEGER = /^-?\d+$/;
/**
 *  数字
 */
RegEnum._NUMBER = /^[0-9]*$/;
/**
 * 验证由26个英文字母组成的字符串
 */
RegEnum._ENCHAR = /^[A-Za-z]+$/;
/**
 * 验证由26个大写英文字母组成的字符串
 */
RegEnum._ENCHARD = /^[A-Z]+$/;
/**
 * 验证由26个小写英文字母组成的字符串
 */
RegEnum._ENCHARX = /^[a-z]+$/;
/**
 * 验证由数字和26个英文字母组成的字符串
 */
RegEnum._ENCHARXN = /^[A-Za-z0-9]+$/;
/**
 * 验证由数字、26个英文字母或者下划线组成的字符串
 */
RegEnum._ENCHAR_N = /^\w+$/;
/**
 * 验证汉字
 */
RegEnum._CN = /^[\u4e00-\u9fa5],{0,}$/;
RegEnum._TEL = /\s/;
/**
 * 验证URL
 */
RegEnum._URL = /^(https?:\/\/)([0-9a-z.]+)(:[0-9]+)?([/0-9a-z.]+)?(\?[0-9a-z&=]+)?(#[0-9-a-z]+)?/i;
