"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MethodRequestFactory = void 0;
const Request_1 = require("../model/Request");
const BeanFactory_1 = require("../BeanFactory");
const BaseController_1 = require("../controller/BaseController");
/**
 * 方法请求 工厂
 */
class MethodRequestFactory {
    /**
     * 获取请求对象
     * @param methodName?
     * @param data
     */
    requestR(methodName, data) {
        // @ts-ignore
        let methodName2 = (methodName != undefined && methodName != null) ? methodName : this.findMethod((new Error()).stack);
        let controller = BeanFactory_1.BeanFactory.getBeanModel(this).info.get(BeanFactory_1.BeanFactory.getName(this));
        let method = controller.methodMap.get(methodName2);
        if (method == null) {
            method = BeanFactory_1.BeanFactory.getBeanModel(BaseController_1.default).info.get(BeanFactory_1.BeanFactory.getName(BaseController_1.default)).methodMap.get(methodName2);
        }
        // @ts-ignore
        return new Request_1.Request(controller.group == null ? "" : `${controller.group}` + `/${controller.path}/${method.path}`, data, method.method, method.dataType, controller.group, controller.name);
    }
    /**
     * 查找方法
     * @param stack
     */
    findMethod(stack) {
        let e = false, ii = 0, x = stack.split("\n");
        for (let i = 0; i < x.length; i++) {
            let d = x[i];
            if (d.indexOf("requestR") != -1) {
                e = true;
                ii = i;
                continue;
            }
            if (!e) {
                continue;
            }
            let sMethod;
            if (d.indexOf("request") != -1 || x[i].indexOf("requestT") != -1) {
                sMethod = x[i + 1];
            }
            else {
                sMethod = x[i];
            }
            sMethod = sMethod.trim();
            if (sMethod.indexOf("@") != -1) {
                sMethod = sMethod.split("@")[0];
            }
            else {
                sMethod = sMethod.trim().split(" ")[1];
                let s = sMethod.split(".");
                sMethod = s.length == 2 ? s[1] : s[0];
            }
            return sMethod.trim();
        }
        return "";
    }
    /**
     * 获取请求参数
     * @param data
     */
    request(data) {
        return this.requestR(undefined, data);
    }
    /**
     * 获取自定义请求对象
     * @param methodName 方法名称
     * @param data 当前泛型对象
     */
    requestT(data) {
        return this.requestR(undefined, data);
    }
}
exports.MethodRequestFactory = MethodRequestFactory;
